package com.cool.hot100.dp;

import org.junit.Test;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/25/23:23
 * @Description: 152. 乘积最大子数组
 * Level 4
 * DayNumber 4
 * Hard 2
 * @Link https://leetcode.cn/problems/maximum-product-subarray/description/?envType=study-plan-v2&envId=top-100-liked
 */
public class Num152 {

    public int maxProduct(int[] nums) {
        int length = nums.length;
        long[] maxF = new long[length];
        long[] minF = new long[length];
        for (int i = 0; i < length; i++) {
            maxF[i] = nums[i];
            minF[i] = nums[i];
        }
        for (int i = 1; i < length; ++i) {
            maxF[i] = Math.max(maxF[i - 1] * nums[i], Math.max(nums[i], minF[i - 1] * nums[i]));
            minF[i] = Math.min(minF[i - 1] * nums[i], Math.min(nums[i], maxF[i - 1] * nums[i]));
            if (minF[i] < (-1 << 31)) {
                minF[i] = nums[i];
            }
        }
        int ans = (int) maxF[0];
        for (int i = 1; i < length; ++i) {
            ans = Math.max(ans, (int) maxF[i]);
        }
        return ans;
    }
    public int maxProduct1(int[] nums) {
        int length=nums.length;
        int[] maxArr=new int[length];
        int[] minArr=new int[length];
        for(int i=0;i<length;i++){
            minArr[i]=nums[i];
            maxArr[i]=nums[i];
        }
        for(int i=1;i<length;i++){
            minArr[i]=Math.min(minArr[i-1]*nums[i],Math.min(nums[i],maxArr[i-1]*nums[i]));
            maxArr[i]=Math.max(maxArr[i-1]*nums[i],Math.max(nums[i],minArr[i-1]*nums[i]));
        }
        int res=maxArr[0];
        for(int i=1;i<length;i++){
            res=Math.max(res,maxArr[i]);
        }
        return res;
    }
    /**
     * @Author Cool
     * @Date 0:35 2024/9/26
     * 滚动数组
     **/
    public int maxProduct2(int[] nums) {
        int length=nums.length;
        int maxArr=nums[0];
        int minArr=nums[0];
        int res=nums[0];
        for(int i=1;i<length;i++){
            int maxTemp=maxArr,minTemp=minArr;
            minArr=Math.min(minTemp*nums[i],Math.min(nums[i],maxTemp*nums[i]));
            maxArr=Math.max(maxTemp*nums[i],Math.max(nums[i],minTemp*nums[i]));
            res=Math.max(res,maxArr);
        }
        return res;
    }
    @Test
    public void test(){
        maxProduct2(new int[]{2,3,-2,4});
    }
}
