package com.cool.hot100.dp;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/24/14:10
 * DayNumber 1
 * Hard 2
 * Level ?
 */
public class Num198 {
    /**
     * 滚动数组
     * @param nums
     * @return
     */
    public int rob(int[] nums) {
        int noSteal=0;
        int steal=nums[0];
        for(int i=1;i<nums.length;i++){
            int noStealTemp=noSteal;
            noSteal=Math.max(noSteal,steal);
            steal=noStealTemp+nums[i];
        }
        return Math.max(noSteal,steal);
    }

    /**
     * 非滚动数组
     * @param nums
     * @return
     */
    public int rob1(int[] nums) {
        int[][]dp=new int[nums.length][2];
        dp[0][0]=0;
        dp[0][1]=nums[0];
        for(int i=1;i<nums.length;i++){
            dp[i][0]=Math.max(dp[i-1][0],dp[i-1][1]);
            dp[i][1]=dp[i-1][0]+nums[i];
        }
        return Math.max(dp[nums.length-1][0],dp[nums.length-1][1]);
    }

}
