package com.cool.hot100.stack;

import java.util.Stack;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/16/17:52
 * DayNumber 2
 * Hard 2
 * Level 6
 */
public class Num394 {
    public String decodeString(String s) {
        StringBuilder res = new StringBuilder();
        int multi = 0;
        Stack<Integer> multiStack = new Stack<>();
        Stack<String> resStack = new Stack<>();
        for (char c : s.toCharArray()) {
            if (c == '[') {
                multiStack.push(multi);
                multi = 0;
                resStack.push(res.toString());
                res = new StringBuilder();
            } else if (c == ']') {
                int currentMulti = multiStack.pop();
                StringBuilder temp = new StringBuilder();
                for (int i = 0; i < currentMulti; i++) {
                    temp.append(res);
                }
                res = new StringBuilder(resStack.pop() + temp);
            } else if (c >= '0' && c <= '9') {
                multi = multi * 10 + Integer.parseInt(c + "");
            } else {
                res.append(c);
            }
        }
        return res.toString();
    }
}
